/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package lezione260410_lista;

/**
 *
 * @author utente
 */
public class List {
    private Elem head;

    public List(){
        head=null;
    }

    public List(Elem e){
        head=e;
        if (e != null){
            e.prev=null;
        }
    }

    public Elem getHead(){
        return head;
    }

    public boolean isEmpty(){
       return head==null;
    }
    //inserisce la chiave k nella lista
    public void Insert (int k){
        Elem e = new Elem(k);
        if (!isEmpty()){
            head.prev=e;
        }
        e.next=head;
        head=e;
    }

    public void Delete (Elem x){
        if (x==null) return;
        if (x.prev != null) {
            (x.prev).next=x.next;
        } else {
            head=x.next;
        }
        if (x.next != null){
            (x.next).prev=x.prev;
        }
    }

     public String toString(){
         Elem e=head;
         String s="";
         while (e != null){
             s += e.toString();
             if (e.next != null) { s+="; ";}
             e = e.next;
         }
         return s+".";
     }

     //restituisce la lunghezza della lista corrente
     public int length(){
         int n=0;
         Elem e=head;
         while (e != null){
             n++;
             e=e.next;
         }
         return n;
     }

     public int length_Ric(){
       return length_Ric_App(head);
     }

     private int length_Ric_App(Elem x){
         if (x==null) {return 0;}
         else {return 1+length_Ric_App(x.next);}
     }

    //aggiungiamo un parametro h intero. Voglio la somma di tutti i valori
    //che sono almeno k
     public int somma_Ric(int h){
       return somma_Ric_App(h, head);
     }

     private int somma_Ric_App(int h, Elem x){
         if (x==null) {return 0;}
         else {
             if (x.getKey()>=h){return x.getKey()+somma_Ric_App(h,x.next);}
             else {return somma_Ric_App(h,x.next);}
         }
     }

     public int somma_Alternata(){
         boolean flag=true;
         int somma=0;
         Elem e=head;
         while (e!=null){
             if (flag) {somma +=e.getKey();}
             e=e.next;
             flag=!flag;
         }
         return somma;
     }

      public int somma_Alternata_Ric(){
          return somma_Alternata_Ric_App(head,true);
     }

      private int somma_Alternata_Ric_App(Elem x, boolean flag){
          if (x==null) return 0;
          if (flag){
              return x.getKey()+somma_Alternata_Ric_App(x.next, false);
          }
          else {
              return somma_Alternata_Ric_App(x.next, true);
          }
     }

     // Calcola il massimo in modo ricorsivo
     //il massimo elemento di una lista vuota è 0
     public int max(){
        return max_App(head);
     }

     private int max_App(Elem x){
         if (x==null) return 0;
         int max_next = max_App(x.next);

         if (x.getKey()>max_next) {
             return x.getKey();
         }
         else
         {
             return max_next;
         }
     }


     //cerca la chiave k nella lista e restituisce il puntatore all'elemento
     // che la contiene, null altrimenti
     public Elem Search (int k){
         Elem e=head;
         while (e != null){
             if (e.getKey()==k) {
                 return e;
             }
             e=e.next;
         }
         return null;
     }

      public Elem Search_Ric (int k){
          return Search_Ric_App (k, head);
      }

      private Elem Search_Ric_App (int k, Elem e){
          if (e==null) {return null;}
          if (k==e.getKey()) {return e;}
          return Search_Ric_App (k, e.next);
      }


}
